* -------------------------------
* 	LPS Example
*
* 	Absolute Beginners
*
*	Language: MC68K-ASM1
*	Style: plain MC68000
* 	Version: Ref-m68k
* -------------------------------

* Complete Example

* Questo esempio mostra
* 1) Accesso alla memoria tramite indirizzi "assoluti", ovvero espressi
*	 come numeri
* 2) Uso di espressioni aritmetiche con numeri per esprimere indirizzi
* 3) Esempi di uso delle istruzioni di trasferimento dati

* Questo esempio e' realizzato per l'assembler ASM-One V1.48
* Per eseguire il programma si puo' usare dalla CLI di ASM-One il comando g
; indicando "inizio_codice" come indirizzo iniziale e "fine_codice" come breakpoint 

* Sezione Codice: questo programma contiene solo una sezione codice e accede
* a indirizzi di memoria che non sono contenuti in nessuna sezione
* Assume che sia possibile scrivere agli indirizzi $00004000 e successivi

	org	$2000
inizio_codice:

* scrittura in memoria: scrive il valore $73727170
* nella long di indirizzo $00004000
	move.l	#$73727170,$00004000

* copia memoria-memoria: il contenuto della word di indirizzo $00004002
* 	viene copiata nella word di indirizzo $0000400c
	move.w	$00004002,$0000400c

* operazioni aritmetiche con operando in memoria: il contenuto del byte
*	di indirizzo $0000400c viene diminuito di 3
	sub.b	#3,$0000400c

* endianess: copia il contenuto della long a indirizzo $00004000 in d7 e poi
; copia ciascuno dei 4 byte che la compongono, in uno dei registri d0-d3
	move.l	$00004000,d7
	move.b	$00004000+0,d0
	move.b	$00004000+1,d1
	move.b	$00004000+2,d2
	move.b	$00004000+3,d3
	

* allineamento: dimostra vincoli di allineamento di MC68000
* de-commentando le istruzioni che effettuano accessi illegali,
* vengono generate eccezioni
	move.b	d7,$00004010	* accesso formato byte a indirizzo pari: OK
	move.b	d7,$00004011	* accesso formato byte a indirizzo dispari: OK
	
	move.w	d7,$00004016	* accesso formato word a indirizzo pari: OK
*	move.w	d7,$00004017	* accesso formato word a indirizzo dispari: KO

	move.l	d7,$00004018	* accesso formato long a indirizzo multiplo di 4: OK
*	move.l	d7,$00004021	* accesso formato long a indirizzo dispari: KO
	move.l	d7,$00004022	* accesso formato long a indirizzo pari
				* ma *non*multiplo di 4: OK

fine_codice:
