# -------------------------------
# 	LPS Example
#
# 	Absolute Beginners
#
#	Language: MIPS32-MARS
#	Style: plain MIPS32
# 	Version: Ref-mips
# -------------------------------

# Complete Example

# Questo esempio mostra
# 1) Accesso alla memoria tramite indirizzi "assoluti", ovvero espressi come numeri
# 2) Uso di espressioni aritmetiche con numeri per esprimere indirizzi
# 3) Esempi di uso delle istruzioni di trasferimento dati

# Sezione Codice: questo programma contiene solo una sezione codice e accede
# a indirizzi di memoria che non sono contenuti in nessuna sezione
	.text

# scrittura in memoria: scrive il valore 0x73727170
# nella word di indirizzo 0x10011000
	li	$t5,0x73727170
	sw	$t5,0x10011000


# copia memoria-memoria: il contenuto della half di indirizzo 0x10011002
# 	viene copiata nella half di indirizzo 0x1001100c
	lh	$t5,0x10011002
	sh	$t5,0x1001100c

# operazioni aritmetiche con operando in memoria: il contenuto del byte
#	di indirizzo 0x1001100c viene diminuito di 3
	lb	$t5,0x1001100c
	sub	$t5,$t5,3
	sb	$t5,0x1001100c

# endianess: copia il contenuto della word a indirizzo 0x10011000 in $s0 e poi
# copia ciascuno dei 4 byte che la compongono, in uno dei registri $t0-$t3
	lw	$s0,0x10011000
	lbu	$t0,0x10011000
	lbu	$t1,0x10011001
	lbu	$t2,0x10011002
	lbu	$t3,0x10011003

# allineamento: dimostra vincoli di allineamento di MIPS32
# de-commentando le istruzioni che effettuano accessi illegali,
# vengono generate eccezioni
	sb	$s0,0x10011010	# accesso formato byte a indirizzo pari: OK
	sb	$s0,0x10011011	# accesso formato byte a indirizzo dispari: OK
	
	sh	$s0,0x10011016	# accesso formato half a indirizzo pari: OK
	sh	$s0,0x10011017	# accesso formato half a indirizzo dispari: KO

	sw	$s0,0x10011018	# accesso formato word a indirizzo multiplo di 4: OK
#	sw	$s0,0x10011021	# accesso formato word a indirizzo dispari: KO
#	sw	$s0,0x10011022	# accesso formato word a indirizzo pari
				# ma *non*multiplo di 4: KO
